// GraphicShapesUI.cpp : implementation file
//

#include "stdafx.h"
#include "GraphicShapesLab.h"
#include "GraphicShapesUI.h"
#include ".\graphicshapesui.h"
#include <iostream>
#include <sstream>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// GraphicShapesUI dialog



GraphicShapesUI::GraphicShapesUI(CWnd* pParent /*=NULL*/)
	: CDialog(GraphicShapesUI::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void GraphicShapesUI::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(GraphicShapesUI, CDialog)
    ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_CIRCLEBUTTON, OnBnClickedCirclebutton)
	ON_BN_CLICKED(IDC_LINEBUTTON, OnBnClickedLinebutton)
	ON_BN_CLICKED(IDC_SQUAREBUTTON, OnBnClickedSquarebutton)
	ON_WM_CLOSE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
END_MESSAGE_MAP()


// GraphicShapesUI message handlers

BOOL GraphicShapesUI::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void GraphicShapesUI::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		HandlePaintEvent();		// the method that does the actual drawing.
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR GraphicShapesUI::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//************************************************************************************
//************************************************************************************
//************************************************************************************
// CS1030 TODO: Add implementation to all of the following methods.
//************************************************************************************
//************************************************************************************
//************************************************************************************

// The handler for the Line button clicked event
// Set a private member state variable to indicate you're in Line mode
void GraphicShapesUI::OnBnClickedLinebutton()
{
#ifdef _DEBUG
	// sample debugging output
	std::ostringstream ostr;
	ostr << "Line Button pressed.\n";
	TRACE( (ostr.str()).c_str() );
#endif
	// CS1030 TODO: Add your code here to switch to Line mode
}

// The handler for the Square button clicked event
// Set a private member state variable to indicate you're in Square mode
void GraphicShapesUI::OnBnClickedSquarebutton()
{
#ifdef _DEBUG
	// sample debugging output
	std::ostringstream ostr;
	ostr << "Square Button pressed.\n";
	TRACE( (ostr.str()).c_str() );
#endif
	// CS1030 TODO: Add your code here to switch to Square mode
}

// The handler for the Circle button clicked event
// Set a private member state variable to indicate you're in Circle mode
void GraphicShapesUI::OnBnClickedCirclebutton()
{
#ifdef _DEBUG
	// sample debugging output
	std::ostringstream ostr;
	ostr << "Circle Button pressed.\n";
	TRACE( (ostr.str()).c_str() );
#endif
	// CS1030 TODO: Add your code here to switch to Circle mode
}

// The handler for mouse left-button pressed events
void GraphicShapesUI::OnLButtonDown(UINT nFlags, CPoint point)
{
	// CS1030 TODO: Add your "mouse button down" message handler code here 
	// You want to save the coordinates of the point where the mouse was
	// when the button was pressed down.
#ifdef _DEBUG
	std::ostringstream ostr;
	ostr << "Mouse down at " << point.x << ", " << point.y << std::endl;
	TRACE( (ostr.str()).c_str() );
#endif
}

// The handler for mouse left-button released events
void GraphicShapesUI::OnLButtonUp(UINT nFlags, CPoint point)
{
	// CS1030 TODO: Add your "mouse button up" message handler code here;
	// You want to retrieve the previously saved coordinates from where the mouse was when
	// the button was pressed down, and get the current coordinates where the mouse button
	// was released. Use these pairs of coordinates to construct your object. The type of
	// object depends on what mode you're currently in.

#ifdef _DEBUG
	std::ostringstream ostr;
	ostr << "Mouse up at " << point.x << ", " << point.y << std::endl;
	TRACE( (ostr.str()).c_str() );

#endif
	Invalidate();		// forces a repaint event to be generated.
}


// The handler for the repaint event, called by Windows whenever the window needs repainting.
// CS1030 TODO: This is where you want to iterate through your shapes collection and redraw each shape.
// You draw by calling the virtual Draw method of each Shape-derived class via the Shape pointer.
// You must pass the Device Context (dc) to the Draw method.
void GraphicShapesUI::HandlePaintEvent()
{
	    CPaintDC dc(this);					// the drawing context, or canvas; DO NOT REMOVE
#ifdef _DEBUG
	    // debugging output 
		std::ostringstream ostr;
		ostr << "Painting" << std::endl;
		TRACE( (ostr.str()).c_str() );
#endif

		// CS1030 TODO: Here is some sample code to show you how to draw a lines from the origin.
		// You'll replace this code with your own that draws the Lines, Circles, and Squares in your Shape collection.
		// Look up CPaintDC to determine what methods you need to use to draw circles and rectangles
		CPen pen(PS_SOLID, 1, RGB(0,0,255)); // Create a solid blue pen of width 1.
		dc.SelectObject( &pen );			 // use the blue pen in this context
		dc.MoveTo(0,0);						 // move the graphics cursor to the origin
		CRect rect;							// rectangle object
		GetClientRect(&rect);				// get coordinates of the drawable area
		dc.LineTo( rect.Width(), rect.Height() );	// and draw to the opposite corner
}


// The handler for the window close event, called by Windows when the user
// clicks the Close icon in the title bar.
// This is where you want to iterate through your shapes collection and delete each shape,
// as well as any other objects you created dynamically (with 'new').
void GraphicShapesUI::OnClose()
{
	// CS1030 TODO: Add your cleanup code here to delete your shapes collection
#ifdef _DEBUG
	    // debugging outout 
		std::ostringstream ostr;
		ostr << "Closing...goodbye world!" << std::endl;
		TRACE( (ostr.str()).c_str() );
#endif

	CDialog::OnClose();
}
